
// YAServerDlg.h : ͷļ
//

#pragma once
#include "afxwin.h"
#include "resource.h"
#include "structdef.h"
#include "constdef.h"
#include "def_msg.h"
#include "socketdef.h"
#include "ReportCtrl/ReportCtrl.h"

#include <sio_client.h>
#include "../thirdparty/include/iocp/Src/TcpServer.h"
#include "../thirdparty/include/iocp/Global/helper.h"
#include "afxcmn.h"
#include "./SyncTime/SyncManager.h"
#include "classdef.h"
#include "QueueStrManager.h"

using namespace sio;
using namespace std;
using namespace HostServer;

struct  _SLS // system_limit_setting
{
	unsigned int over_count_person;
	unsigned int over_count_vehicle;
	unsigned int over_time_person;
	unsigned int over_time_vehicle;
	double over_speed;
};

struct _DBS // db setting
{
	string host;
	string user;
	string password;
	string dbname;
	string encoding;
	int port;
};

struct _SOCK
{
	CString sip;
	DWORD dwConnID;
	int state; // 0 
	DWORD reader_id; // վ
};

struct _SOCKET_BUFFER
{
	DWORD dwConnID;
	BYTE pData[LENGTH_MSG_1M]; 
	WORD wLen;
	WORD wReadLen;
};

// CYAServerDlg Ի
class CYAServerDlg : public CDialogEx, public CTcpServerListener
{
	typedef map<string, Card*> CardMap;
	typedef map<CString, _SOCK*> SocketMap;
	typedef map<DWORD, _SOCKET_BUFFER*> SocketBufferMap;
	struct LogMsg
	{
		CString strFile;
		CString strLog;
		bool isNeedTime;
	};
	struct DataMsg
	{
		CONNID dwConnID;
		int iLength;
		BYTE* pData;		
	};
	// 
public:
	CYAServerDlg(CWnd* pParent = NULL);	// ׼캯
	~CYAServerDlg();
	// Ի
	enum { IDD = IDD_YASERVER_DIALOG };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV ֧
private:
	virtual EnHandleResult OnPrepareListen(ITcpServer* pSender, SOCKET soListen);
	virtual EnHandleResult OnAccept(ITcpServer* pSender, CONNID dwConnID, SOCKET soClient);
	virtual EnHandleResult OnSend(ITcpServer* pSender, CONNID dwConnID, const BYTE* pData, int iLength);
	virtual EnHandleResult OnReceive(ITcpServer* pSender, CONNID dwConnID, const BYTE* pData, int iLength);
	virtual EnHandleResult OnClose(ITcpServer* pSender, CONNID dwConnID, EnSocketOperation enOperation, int iErrorCode);
	virtual EnHandleResult OnShutdown(ITcpServer* pSender);
	// ʵ
protected:
	HICON m_hIcon;

	// ɵϢӳ亯
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()
public:
	CButton m_btStart;
	CButton m_btStop;
	CMenu m_mnMain;
	afx_msg LRESULT on_monitor(WPARAM wParam, LPARAM lParam);
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnBnStop();
	afx_msg void OnBnStart();	
	afx_msg void OnBnExit();
	afx_msg void OnBnSyncTime();
	afx_msg void OnMenuDb();
	afx_msg void OnMenuLog();
	afx_msg void OnMenuParam();
	afx_msg void OnBnCallHisData();
public: 
	// ui operation
	CTcpServer _server;
	HostServer::SyncManager syncmanager;
	EnAppState m_enState;
	CStdioFile cfErrorLog;
	CRITICAL_SECTION m_csWriteLog;
	CRITICAL_SECTION m_csRemoveSocket;
	CRITICAL_SECTION m_csRefreshList;
	CRITICAL_SECTION m_csParseDataServer;
	CRITICAL_SECTION m_csSyncTime;
	CRITICAL_SECTION m_csAddDist;
	CRITICAL_SECTION m_csCallInfo;

	QueueStrManager* m_qsmSQL;

	void set_app_state(EnAppState eas);
	void start_tcp_server();
	void stop_tcp_server();	
public:
	CString m_strConncetion; // ݿַ
	int m_nPort; // ˿
	int m_nCountClick;

	CWinThread* m_thread_monitor; // سͨ߳
	CWinThread* m_thread_timer; // timeṛ߳UỊ߳ʹontimer
	unsigned int m_uint_state; // ɼ״̬
	// bit 0, ״̬л߹ر
	// bit 1, ɼ״̬쳣
	// bit 2, վ״̬жϻû
	// bit 3, websocket״̬δ
	// bit 4, ݿ״̬δ
	time_t m_time_last_rec; // յվݵʱ
	bool is_websocket_ok; //
	bool is_websocket_login;
	bool is_server_ok; // 
	bool is_database_ok; //
	BOOL m_bUseFilter;

	int m_nFilterType;
	int m_nMallocTimes;

	BOOL m_log_sys_status;
	BOOL m_log_raw_data;
	BOOL m_log_parse_data;
	BOOL m_log_send_package;
	BOOL m_log_recv_package;
	BOOL m_log_locate_data;

	time_t time_over_count_vehicle;
	time_t time_over_count_person;


	BOOL m_bListen;
	SocketMap mp_socket_list;
	SocketBufferMap mp_socket_buffer_list;

	CardMap mp_card_list_all; // п
	ReaderMap mp_reader_list; // зվ
	AreaMap mp_area_list; // 
	MapInfoMap mp_map_list; // еͼ
	DeptMap mp_dept_list; // в
	AlarmTypeMap mp_alarm_type_list;
	ReaderPathMap mp_reader_path_list;	//ǰͼзվĸǷΧ
	TDOAReaderPathMap mp_reader_path_list_tdoa;

	CardMap mp_card_list_down_vehicle; // ³
	CardMap mp_card_list_down_person;  // Ա
	CardMap mp_card_list_down_adhoc;   //

	CardMap mp_card_list_over_time_person; // 
	CardMap mp_card_list_forbidden_person;
	CardMap mp_card_list_help;
	CardMap mp_card_list_area_over_time_person;
	CardMap mp_card_list_forbidden_vehicle;
	CardMap mp_card_list_over_time_vehicle;	
	CardMap mp_card_list_over_speed_vehicle;
	CardMap mp_card_list_area_over_time_vehicle;

	AreaMap mp_area_over_count_person;
	AreaMap mp_area_over_time_person;
	AreaMap mp_area_forbidden_person;
	AreaMap mp_area_over_count_vehicle;
	AreaMap mp_area_over_time_vehicle;
	AreaMap mp_area_forbidden_vehicle;
	unordered_map<DWORD, WORD> umpRootSyncNum;

	CallInfoReaderMap mp_call_info;

	_SLS sls_setting;
	_DBS m_db_setting;
	string m_ws_url;

	double m_reader_interval_time;

public:
	void init_ui();
	void init_param();
	void init_queuestring();
	void load_param_from_ini();
	void database_connect();
	void stop_and_exit();
	void stop_timer();
	void set_run_state();
	// ݿгʼ 
	void init_base_data();
	int init_setting(); // ϵͳ
	int init_alarm_type(); // 
	int init_dept(); // б
	int init_card(string card_id = "");
	int init_staffer(string staff_id = "", bool is_card = false); // Ա
	int init_vehicle(string vehicle_id = "", bool is_card = false); // 
	int init_adhoc(string adhoc_id = "",bool is_card = false); // 
	int init_map(int map_id = 0); // ͼ
	int init_area(int area_id = 0); // 
	int init_reader(int reader_id = 0); // վ
	int init_antenna(int reader_id = 0); // 
	int init_dev_adhoc(int reader_id = 0); // 
	int init_antenna_sync();
	int init_all_readers_coverage(int reader_id = 0);			//ݿȡͼǷΧ,ʼзվĵͼ
	int init_tdoa_all_readers_coverage(int reader_id = 0);			//ݿȡͼǷΧ,ʼзվĵͼ
	int get_help_card_nums();

	// ʷ
	void load_his_data();
	void load_his_down(); // 뾮״̬
	void load_his_area(); // 
	void load_his_reader(); // վ״̬
	void load_his_card_postion(); // λ
	void load_his_card_state();
	// 뱨
	void load_alarm_reader();
	//void load_alarm_area();
	//void load_alarm_mine();
	// ӿݽ
	void parse_edit_map(int map_id);
	void parse_edit_area(int area_id);
	void parse_edit_reader(int reader_id);
	void parse_edit_card(string card_id);
	void parse_edit_staffer(string staffer_id);
	void parse_edit_vehicle(string vehicle_id);
	void parse_edit_path(int path_id);
	void parse_set_limit_value();
	void parse_call_card();
	void parse_clear_card();
	void parse_deal_help();
	// ʼwebsocket
	void ws_init();
	void ws_open();
	void ws_close();
	void ws_login();
	void ws_logout();

	void clear_listener();
	void clear_all_list();
	// socket
	void parse_data_server(const BYTE * pData, int nLen, DWORD dwConnId); // ճ
	void parse_data(BYTE *pData, int nLen, DWORD dwConnID);
	void parse_data_receive_package(BYTE *pData, int nLen, DWORD dwConnID); // ݰճ
	void parse_data_receive(BYTE *pData, int nLen, DWORD dwConnID);
	void parse_package_data(BYTE* DataBuffer, int nLen, DWORD dwConnID); // ͻճ
	// λ
	void parse_data_locate_reader(BYTE * DataBuffer, int& nCurPos, int nLen, DWORD dwConnID, int& reader_id);
	void parse_data_locate_card(BYTE* DataBuffer, int& nCurPos, int reader_id, unsigned short wChr);
	void parse_data_locate_card_vehicle(BYTE* DataBuffer, int& nCurPos,  Card* card, unsigned short wChr);
	void parse_data_locate_reader_his(BYTE * DataBuffer, int nLen, int& nCurPos, int& reader_id, int& nTick, CString& strtime, unsigned short wChr);
	void parse_data_locate_card_his(BYTE* DataBuffer, int& nCurPos, int reader_id, DWORD wTickCount, CString strTime, unsigned short wChr);
	void parse_data_locate_card_his_tdoa(BYTE* DataBuffer, int nLen, int reader_id, DWORD wTickCount, CString strTime);
	void parse_data_locate_card_his_tdoa_package(BYTE* DataBuffer, int nLen, int reader_id, DWORD wTickCount, CString strTime, CString strHistTime);
	void parse_data_locate_card_his_tof_card(BYTE* DataBuffer, int nLen, int reader_id, DWORD wTickCount, CString strTime, CString strHistTime);
	void parse_data_locate_card_his_tdoa_card(BYTE* DataBuffer, int nLen, int reader_id, DWORD wTickCount, CString strTime, CString strHistTime);
	void parse_data_locate_card_his_sync_time(BYTE* DataBuffer, int nLen, CString strTime,  CString strHistTime, WORD wChr);
	// 
	void parse_data_adhoc(BYTE* DataBuffer, int& nCurPos,  int reader_id);
	// վʱͬ
	void parse_data_reader_synctime(BYTE *DataBuffer, int nLen, int& nCurPos, WORD wChr);

	_SOCK* get_socket_by_count(DWORD dwConnID);
	void add_socket_to_list(DWORD dwConnID, DWORD reader_id);
	void remove_socket(DWORD dwConnID);
	// 
	void SendData(DWORD dwConnID, WORD wCharacterWord, int wLength, BYTE* DataBuffer);

	// ȡjson
	string get_json_login();
	string get_json_logout();
	//string get_json_down_mine();
	//string get_json_up_mine();
	string get_json_down_and_up(Card* card);
	string get_json_counting();
	string get_json_position();
	string get_json_position_all();
	string get_json_device_state();
	string get_json_alarm();
	string get_json_call_test();
	string get_json_help();			//json
	// string get_json_postion_test();
	// void send_json_data(string url, string cmd, string data, string ver, string user);
	void send_json_data(string cmd, string data, bool is_login = false);
	// ҵ
	void deal_readers();
	void deal_areas();
	void deal_card_msg(Card* card, bool is_hist = false);
	void deal_hist_card_postion();
	void deal_hist_card_alarm();
	void deal_hist_area();
	void card_enter_mine(Card* card);
	void card_down_mine(Card* card);
	void card_up_mine(Card* card);
	void card_enter_park(Card* card);
	void card_enter_map(Card* card);
	void card_enter_area(Card* card);
	void card_leave_area(Card* card, Area* area);
	void deal_card_state(Card* card);
	void deal_alarm_card(Card* card, CardMap* dest_card_list, bool is_alarm, ALARM_FLAG tag);
	void deal_alarm_area(Area* area, AreaMap* dest_area_list, bool is_alarm, ALARM_FLAG tag);
	void reset_map_card();
	//void reset_area_card();
	bool is_in_rectangle(_point p, double dblleft, double dbltop, double dblright, double dblbottom);
	bool is_in_circle(_point p1, _point p2, double r, double scale);
	// save to database
	void execute_sql(const char* sql); // 浽ݿ
	void save_card_postion(Card* card);
	void store_data_card(Card* card, int tag);
	void store_data_area(Area* area, time_t cur_time, time_t start_time, int tag);
	void store_data_reader(Reader* reader, int tag);
	void store_data_mine(int tag);
	//void store_data_system();

	// 
	void package_data();
	void package_data_test();
	// ͨ÷
	int API_TimeToString(string &strDateStr,const time_t &timeData);
	int API_StringToTime(const string &strDateStr,time_t &timeData);
	void formatByteArray(CString &strBuf, BYTE * buf, int nLen);
	void writeErrorLog(const CString strFile, const CString strErr ,bool bTime = true);
	void writeErrorLogEx(const CString strFile, const CString strErr ,bool bTime = true);
	void writeErrorLogEx(const char* strFile, const char* strErr ,bool bTime = true);
	BOOL openLogFile(const CString strFile);
	BOOL openLogFile(const char* strFile);
	void show_log( LPCTSTR szlog, BOOL bSave = true);
	void AddItem(CString strvalue, int readerid, BOOL is_closed = false);
	// Ӧӿ
	void parse_json_data_set_limit_value(const char* sz);
	void parse_json_data_call_card_cancel(message::ptr const& data);
	void parse_json_data_call_card(message::ptr const& data);//(const char* sz);
	void parse_json_data_clear_card(const char* sz);
	void parse_json_data_deal_help(const char* sz);
	//void parse_json_data_edit_map(const char* sz);
	//void parse_json_data_edit_area(const char* sz);
	//void parse_json_data_edit_reader(const char* sz);
	////void parse_json_data_edit_path(const char* sz);
	//void parse_json_data_edit_card(const char* sz);
	//void parse_json_data_edit_staffer(const char* sz);
	//void parse_json_data_edit_vehicle(const char* sz);
	void deal_call_edit_map(int id, EDIT_TYPE_ID edit_type_id);
	void deal_call_edit_area(int id, EDIT_TYPE_ID edit_type_id);
	void deal_call_edit_reader(int id, EDIT_TYPE_ID edit_type_id);
	void deal_call_edit_card(string id, EDIT_TYPE_ID edit_type_id);
	void deal_call_edit_staff(string id, EDIT_TYPE_ID edit_type_id);
	void deal_call_edit_vehicle(string id, EDIT_TYPE_ID edit_type_id);
	void deal_call_edit_adhoc(string id, EDIT_TYPE_ID edit_type_id);
	void remove_card(string card_id);

	void send_call_info();
	void send_call_his_data();
	void send_sync_reader();
	void clear_call_info();
	int get_card_id_len(int card_type);
	void release_memory();
	void release_area_memory();
	void release_map_memory();
	void release_card_memory();
	void release_reader_memory();
	void release_dept_memory();
	void Test();
public:
	std::unique_ptr<client> _io;
	CListBox m_list_log;
	CReportCtrl m_listctrl_reader;

	void OnPushMessage();
	void OnCallMessage(string const& name, message::ptr const& data, bool isAck,message::list &ack_resp); 
	//void OnCallMessage(string const& name, message::ptr const& data, bool isAck = false,message::list &ack_resp = nullptr); 
	void OnLoginCallBack(message::list const& msglist = nullptr);
	void OnLogin(string const& name, message::ptr const& data, bool isAck, message::list &ack_resp);

	void OnConnected();
	void OnClosed(client::close_reason const& reason);
	void OnFailed();
protected:
	afx_msg LRESULT OnRemoveSocket(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnMsgRefreshIpList(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnWriteErrorLog(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnCardAddDist(WPARAM wParam, LPARAM lParam);
public:
	UINT m_reader_id_hist;
	afx_msg void OnEnUpdateEditReaderid();
	afx_msg void OnAbout();
};