#ifndef YASERVER_CLASSDEF_H_
#define YASERVER_CLASSDEF_H_

#define MAX_DIST_CACHE 4  //5
#define DIST_COUNT 4
#define ANCHOR_COUNT 4

#define KALMAN_OFFSET_COOR 0.01
#define KALMAN_OFFSET_MOVE 1
#define KALMAN_OFFSET_RANGING 0.01
#define KALMAN_INTERVAL 0.3

#define KALMAN_OFFSET_COOR_TRI 0.01
#define KALMAN_OFFSET_MOVE_TRI 1
#define KALMAN_OFFSET_RANGING_TRI 0.09
#define KALMAN_INTERVAL_TRI 1

#define ANTENNA_COUNT 2
#define ADHOC_COUNT 10
#define READER_TIMEOUT 20
#define OVER_TIME 480 * 60

//#define CARD_TYPE_ADHOC 3
#define MAX_SEMACOUNT 64
#define INVALID_COORDINATE -1

//㷨
//#define ALGORITHM_TYPE_TOF
#define ALGORITHM_TYPE_TDOA
//#define ALGORITHM_TYPE_INS		//ʹùߵж

//˲ܿ
//#define FILTER_KALMAN

#include <string>
#include <ctime>
#include <map>
#include <iostream>  
#include <string>  
#include <vector>
#include <unordered_map>
#include <deque>
//#include "winsock2.h"
#include <kalman\locate.h>
#include "Filter\KalmanFilter.h"

#define MIN(x,y) (x < y ? x : y)
#define MAX(x,y) (x > y ? x : y)

using namespace std;

const int MAX_CALC_POINTS = 30;
const double INS_WEIGHT = 9.0;	//ߵȨ
const double UWB_WEIGHT = 1.0;  //UWBȨ

enum TIMER_ID
{
	TMR_SEND_COUNTING = 1,
	TMR_SEND_ALARM,
	TMR_SEND_DEVICE_STATE,
	TMR_SEND_POSTION,
	TMR_SYNC_READER_TIME,
	TMR_CLEAR_CALL_TIMER,
	TMR_SEND_CALL
};

enum ALARM_FLAG{
	AF_CARD_OVER_COUNT = 1,
	AF_CARD_OVER_TIME,
	AF_CARD_OVER_SPEED,
	AF_CARD_AREA_OVER_TIME,
	AF_CARD_AREA_OVER_COUNT,
	AF_CARD_AREA_FORBIDDEN,//1 Ҫs
	AF_AREA_OVER_COUNT,
	AF_AREA_OVER_TIME,
	AF_AREA_FORBIDDEN	//2

};

enum EDIT_TYPE_ID{
	ET_INSERT = 0,
	ET_UPDATE,
	ET_DELETE
};

enum ALARM_TYPE_ID
{
	ATID_OVER_COUNT_PERSON = 1,
	ATID_OVER_TIME_PERSON,
	ATID_AREA_OVER_COUNT_PERSON,
	ATID_AREA_OVER_TIME_PERSON,
	ATID_AREA_LIMIT_PERSON,
	ATID_AREA_FORBIDDEN_PERSON,
	ATID_READER,
	ATID_OVER_SPEED,
	ATID_RUN_THE_RED_LIGHT,
	ATID_POWER,
	ATID_OVER_COUNT_VEHICLE,
	ATID_OVER_TIME_VEHICLE,
	ATID_AREA_OVER_COUNT_VEHICLE,
	ATID_AREA_OVER_TIME_VEHICLE,
	ATID_AREA_LIMIT_VEHICLE,
	ATID_AREA_FORBIDDEN_VEHICLE
};

enum STATUS_DEVICE{
	STATUS_DEVICE_NORMAL = 1,
	STATUS_DEVICE_ERROR,
};

enum STATUS_CARD
{
	STATUS_NORMAL = 0,				//
	STATUS_ERROR = 1, 
	STATUS_ERROR_SERIOUS = 2,

	STATUS_POWER_LOWER = 1,			//
	STATUS_POWER_LOWER_SERIOUS = 2, //
	STATUS_OVER_TIME = 4,			//ʱ
	//STATUS_OVER_COUNT = 1,
	STATUS_OVER_SPEED = 8,			//
	STATUS_AREA_OVER_TIME = 16,		//ʱ
	//STATUS_AREA_OVER_COUNT = 1,
	STATUS_AREA_OVER_SPEED = 32,	//
	STATUS_AREA_FORBIDDEN = 64,		//
	STATUS_HELP = 128,				//
	STATUS_HELP_DEALED = 256,		//
	STATUS_CALL = 512,				//
	STATUS_LOST = 1024				//ä
	//STATUS_ERROR_DEALED,
};

enum STORE_CARD_DATA_FLAG{
	TEST_LOCATE_COMPARE = 0,
	TEST_LOCATE_DATA,
	HIS_LOCATION,
	HIS_RAW_DATA,
	HIS_AREA_LOCATION_ENTER,
	HIS_AREA_LOCATION_LEAVE,
	RPT_ATTEND_DOWN,
	RPT_ATTEND_UP,
	ALARM_CARD_OVER_TIME_START,
	ALARM_CARD_OVER_TIME_END,
	ALARM_CARD_OVER_SPEED_START,
	ALARM_CARD_OVER_SPEED_END,
	//ALARM_CARD_LOST_START,
	//ALARM_CARD_LOST_END,
	ALARM_CARD_LOW_POWER_START,
	ALARM_CARD_LOW_POWER_END,
	ALARM_CARD_OVER_TIME_AREA_START,
	ALARM_CARD_OVER_TIME_AREA_END,
	ALARM_CARD_OVER_SPEED_AREA_START,
	ALARM_CARD_OVER_SPEED_AREA_END,
	ALARM_CARD_AREA_FORBIDDEN_START,
	ALARM_CARD_AREA_FORBIDDEN_END,
	ALARM_CARD_HELP_START,
	ALARM_CARD_HELP_END
};
enum STORE_AREA_DATA_FLAG{
	ALARM_AREA_OVER_COUNT_PERSON_START = 0,
	ALARM_AREA_OVER_COUNT_PERSON_END,
	ALARM_AREA_OVER_COUNT_VEHICLE_START,
	ALARM_AREA_OVER_COUNT_VEHICLE_END,
	ALARM_AREA_FORBIDDEN_PERSON_START,
	ALARM_AREA_FORBIDDEN_PERSON_END,
	ALARM_AREA_FORBIDDEN_VEHICLE_START,
	ALARM_AREA_FORBIDDEN_VEHICLE_END,
};

enum STORE_READER_DATA_FLAG{
	ALARM_READER = 0,
	ALARM_READER_LOST_START,
	ALARM_READER_LOST_END
};

enum STORE_MINE_DATA_FLAG{
	ALARM_MINE_OVER_COUNT_PERSON_START = 0,
	ALARM_MINE_OVER_COUNT_PERSON_END,
	ALARM_MINE_OVER_COUNT_VEHICLE_START,
	ALARM_MINE_OVER_COUNT_VEHICLE_END
};

enum LOCATE_TYPE
{
	LT_COORDINATE = 0,
	LT_READER,
	LT_TDOA,
};

enum FILTER_TYPE{
	NO_FILTER = 0,
	FILTER_KALMAN = 1,
};


struct SQLTHREAD_DATA//дݿ̴߳ݵĲ
{
	char* pText;//ݿַָ
	int nRepeatTimes;//ѾԼ
};

// λ
struct _coordinate{
	_coordinate(){
		t = 0;
		reader_id = 0;
		tt = 0;
		d = 0.0;
		st = 0;	

		x = 0.0;
		y = 0.0;
		z = 0.0;
		a = 0.0;
		v = 0.0;
		antenna_id = 0;
		d_offset = 0.0;
		special = 0;
		acceleration = 0;
		acce_state = 0;	
	}
	int t; // λʱ
	int reader_id;
	unsigned long long tt;
	double d; // 

	double x; // x
	double y; // y
	double z; // z
	double a; // ƽǶ
	double v; // ٶ
	int antenna_id;
	double d_offset; // ʾƫƣվ

	int st;   //ͬ
	double acceleration;	//ٶ
	int acce_state;	//ٶ״̬
	int special; //վǷվ0վ1ͨվ

	_coordinate& operator=(_coordinate &tmp){
		t = tmp.t;
		reader_id = tmp.reader_id;
		tt = tmp.tt;
		d = tmp.d;
		st = tmp.st;
		x = tmp.x;
		y = tmp.y;
		z = tmp.z;
		a = tmp.a;
		v = tmp.v;
		antenna_id = tmp.antenna_id;
		d_offset = tmp.d_offset;
		special = tmp.special;
		acceleration = tmp.acceleration;
		acce_state = tmp.acce_state;
		return *this;
	}
};

struct _point{ // 
	double x;
	double y;
	double z;
};

struct sync_data{
	double x;
	double y;

	double vx;
	double vy;

	int sync_num;	//ͬ

	bool update;

	sync_data(){
		x = 0.0;
		y = 0.0;
		vx = 0.0;
		vy = 0.0;
		sync_num = 0;
		update = false;
	}

	sync_data& operator=(sync_data&tmp){
		x = tmp.x;
		y = tmp.y;
		vx = tmp.vx;
		vy = tmp.vy;
		sync_num = tmp.sync_num;
		update = tmp.update;
		return *this;
	}
};

struct _call_info_card
{
	int card_id;
	int card_type;
	int call_type;
	string str_card_id;
	time_t start_time;
	int time_out;
	bool is_success;
};
typedef map<std::string, _call_info_card*> CallInfoCardMap;

struct _call_info_reader
{
	bool is_call_all;
	bool is_start_call;		//true,ʼ;false,ȡ
	BYTE call_type;
	int cards_count;
	CallInfoCardMap mpCard;
};
typedef map<int, _call_info_reader*> CallInfoReaderMap;

// վʱ䶨
struct ReceiveData{
	unsigned int reader_id;		// վ
	unsigned short antenna_id;  // ߺ
	long long rec_time_stamp;	// վʱ䣬һ5ֽڵ޷
	int special;
	double x;	//վx
	double y;   //վy
	double z;   //վz
	ReceiveData(){
		reader_id = -1;
		antenna_id = -1;
		rec_time_stamp = 0;
		x = y = z = 0.0;
		special = -1;
	};
};

typedef unordered_map<int,ReceiveData> ReceiveDataMap;
//typedef unordered_map<int,ReceiveData*> ReceiveDataMap;

struct INFO_PRE{
	int t;
	long long detaT;
	double dist;
	int ant;
	int sta_num;
};

struct POS{
	double posx;
	double posy;
	double posz;
	double pos_radius;

	//涨λվϢ
	int nFirstReader;
	int nSecondReader;

	//Ȳο
	double dFirstDiff;
	double dSecondDiff;

	POS(){
		nFirstReader = INVALID_COORDINATE;
		nSecondReader = INVALID_COORDINATE;
		posx = 0;
		posy = 0;
		posz = 0;
		dFirstDiff = 0;
		dSecondDiff = 0;
		pos_radius = 0;
	
	}

	POS& operator=(POS& tmp){
		nFirstReader = tmp.nFirstReader;
		nSecondReader = tmp.nSecondReader;
		posx = tmp.posx;
		posy = tmp.posy;
		posz = tmp.posz;
		dFirstDiff = tmp.dFirstDiff;
		dSecondDiff = tmp.dSecondDiff;
		pos_radius = tmp.pos_radius;

		return *this;
	}
};

struct RESULT{
	double x[3];
	double y[3];
	double z[3];
	int nCount;
};

class Mine;
class Area;
class Reader;
class Card;
class MapInfo;
class Dept;
class ReaderPath;

typedef map<string, Card*> CardMap;
typedef map<int, Area*> AreaMap;
typedef map<int, Reader*> ReaderMap;
typedef map<int, MapInfo*> MapInfoMap;
typedef map<int, Dept*> DeptMap;
typedef map<int, string> AlarmTypeMap;
typedef map<int,ReaderPath*> ReaderPathMap;
typedef unordered_map<int,ReaderPathMap*> TDOAReaderPathMap;
typedef unordered_map<string, _coordinate*> DistMap;

struct DistQueMapItem
{
	WORD cardstamp;
	DistMap distmap;
};
typedef deque<DistQueMapItem> DistQueMap;

// ͼ
class MapInfo{
public:
	MapInfo(void);
	~MapInfo(void);
public:
	int map_id;
	string map_path;
	string map_name;
	double map_width;
	double map_height;
	double map_scale;
	int map_type;

	AreaMap map_area_list;
	ReaderMap map_reader_list;
	CardMap map_card_list_person;
	CardMap map_card_list_vehicle;
};

// 
class Area  // 
{
private:
	std::vector<std::string> split(std::string str,std::string pattern);
	double get_vertex(std::string src); // 
public:
	Area(void);
	~Area(void);
	void init_border(string sz_path);
	bool is_in_polygon(_point p);
public:
	int map_id;
	int area_id;
	string area_name;
	string area_type_name;
	int area_type_id;
	string path; // 
	// Ա
	int over_count_person;
	int over_time_person;
	int under_count_person;
	int under_time_person;
	// 
	int over_count_vehicle;
	int over_time_vehicle;
	int under_count_vehicle;
	int under_time_vehicle;

	int polygon_count;
	_point* polygon;
	// 
	//double x;
	//double y;
	//double z;
	//double sr; // ̰뾶
	//double lr; // 뾶

	//double x1, y1, z1; // ĸ
	//double x2, y2, z2;
	//double x3, y3, z3;
	//double x4, y4, z4;

	double rect_left;
	double rect_right;
	double rect_top;
	double rect_bottom;

	// 
	int count_person;
	int count_vehicle;
	int count_card;

	// Ƿд
	int is_att; // 0 ͣ⣬1 ͣ
	//
	bool is_area_over_time_person; // ʱ
	bool is_area_over_time_vehicle; // Աʱ
	int count_area_over_time_person; // ʱ
	int count_area_over_time_vehicle; // ʱ
	time_t time_over_time_person; // ʼʱʱ
	time_t time_over_time_vehicle; // ʼʱʱ

	bool is_area_over_count_person; // ԱԱ
	bool is_area_over_count_vehicle; // Ա
	int count_area_over_count_person;
	int count_area_over_count_vehicle;
	time_t time_over_count_person; // ʼʱ
	time_t time_over_count_vehicle; // ʼʱ

	bool is_area_forbidden_person;
	bool is_area_forbidden_vehicle;
	int count_area_forbidden_person;
	int count_area_forbidden_vehicle;
	time_t time_forbidden_person; // ʼʱ
	time_t time_forbidden_vehicle; // ʼʱ

	CardMap area_card_list_person;
	CardMap area_card_list_vehicle;
};

// Ԥ
class Adhoc
{
public:
	Adhoc();
	~Adhoc();
public:
	int adhoc_id;
	double x;
	double y;
	double z;
	int idx;
};

// 
class Antenna
{
public:
	Antenna(void);
	~Antenna(void);
public:
	int antenna_id;
	double antenna_x;
	double antenna_y;
	double antenna_z;
	double antenna_angle;
};
// վ
class Reader
{
public:
	Reader(void);
	~Reader(void);
public:
	int reader_id; // վ
	string reader_name; // վ
	int device_type_id;
	int pos_state; // λ״̬ 1ϣ2
	string ip;
	double reader_x; 
	double reader_y;
	double reader_z;
	double reader_angle;

	double reader_interval_time;

	int map_id; // ڵͼ
	int area_id; // 
	double map_scale; // 

	//double rec_time; // ʱ
	time_t rec_time; 
	time_t reader_time; // վʱ
	time_t lost_time;
	int temperature; // ¶
	int tick_count; // 
	int state; // ״̬ 0 , 1 

	int sync_level;

	int state_old; // һ״̬
	Antenna* ant[ANTENNA_COUNT]; // 
	Adhoc* adhoc[ADHOC_COUNT];// ڵԤ
	map<int,_point> readerCoveragePath;
	bool bIsInitCoverage;
	int m_nIsSpecial;

public:
	string get_state_text();
};

// 
class Card
{
public:
	Card(void);
	~Card(void);
	Card(string cardid, int cardtype,double z_offset, double offset_x = 12.0, double offset_y =12.0);

public:
	CRITICAL_SECTION m_csCard;
public:
	int card_type; //  0x01, 0x02
	//int64_t card_id; // Ψһʶ λΪţλΪͣ ((card_id << 8) | card_type)
	string card_id;
	
	// Ա
	string level; // 
	string occupation; // ְ
	// Ա
	string id; // ţԱ
	string name; // 
	string number; // ֤룬ƺ
	string photo; // Ƭ
	string company; // λ
	string department; // 
	int dept_id;
	int group_id;
	string group; //  
	string worktype; // ֡

	//time_t deal_time; // ߼ʱ
	SYSTEMTIME deal_time;
	time_t rec_time; // ʱ
	time_t down_time; // 뾮ʱ
	time_t up_time; // ʱ
	time_t enter_area_time; // ʱ
	time_t enter_reader_time; // վʱ
	time_t low_power_time; // Ϳʼʱ
	//time_t enter_park_time; // سʱ
	//time_t leave_park_time; // ʱ, ʼʱ
	double coor_offset_x;
	double coor_offset_y;
	double x;
	double y;
	double z;
	double a; // ϴζλʱĽǶ
	int t; // ϴζλʱʱ
	double z_offset;
	bool init_postion;
	bool is_first_location;
	double v; //ٶ
	double m_dAverageV; //ƽٶ

	double xx;
	double yy;
	double zz;

	double x1, x2, x3, x4;
	double y1, y2, y3, y4;
	double z1, z2, z3, z4;

	double last_x;
	double last_y;
	double last_z;

	double stored_x;
	double stored_y;
	double stored_z;

	double last_vx;
	double last_vy;

	int state;	// 0  32bit,ÿbitһ״̬:
				// һλ 0x01 ³ʱ, ڶλ 0x02 ʱ, λ 0x04 , λ 0x08, 
				// ״̬ϡ͵
	int state_moving; // ˶״̬ 0 ֹ1 
	int state_biz;    //ҵ״̬/ʱ/

	// ͡ С
	int status_over_time; // 0 δʱ1 ʱ
	int status_over_speed; // 0 δ٣1 
	int status_area_over_time; // 0 δʱ 1 ʱ
	int status_area_over_speed; // 0 δ٣ 1 
	int status_area_forbidden; // 0 δ 1 
	int status_help; // 0 δȣ 1 ȣ 2 Ѵ
	int status_call; // 0 δ 1 
	int status_power; // 0 1 
	int status_lost; // 0 δä1 ä״̬
	
	int map_id; // ǰͼ
	double map_scale; // ͼ
	int map_id_old; // ϴβڵͼ
	int area_id; // ǰ	
	int reader_id; // ǰվ
	Reader* p_reader;
	ReaderPathMap* pReaderPathMap;
	TDOAReaderPathMap* pTdoaReaderPathMap;
	_coordinate** p_dists;
	_coordinate** p_dists_locate;
	_coordinate last_locate;
	_coordinate origin_locate;
	double m_dFirstDiff;
	double m_dSecondDiff;
	
	DistQueMap _dists;
	int time_stamp_max; // ʱҪ㶨λʱ
	int time_stamp_cal;
	//int get_pos_state() const { return pos_state; }
	//void set_pos_state(int val) ;
	//int get_pos_state_count() const { return pos_state_count; }

	int pos_state; // λ״̬0ʼ1£2ϣ3վ
	int pos_state_old;
	//int pos_state_last;
	int pos_state_count; // ǰλ״̬ȷϴ

	int pos_state_park; // ͣ״̬
	int pos_state_park_old;
	//int pos_state_park_last;
	int pos_state_park_count;

	int m_nFilterType;
	int m_nLastLocateT;
	int m_nCalcSyncNum;	//㷨еͬţͬźͿʵʱͬŲһһ
	int m_nSyncNumInList;	//ӶȡĴ5ͬ

	//int last_area_type_id;
	//int cur_area_type_id;

	bool issent; // true ѷͻˣfalse ݣҪͻ
	bool issaved; //true ѱ浽ݿ⣬false µĿڼ¼Ҫ浽ݿ
	bool isdealed; // Ѿ
	bool isreceive; // յ
	bool is_pos_changed;
	bool is_deal_by_algo;
	bool is_hist;
	bool is_need_cal;
	bool m_bUseFilter;

	bool is_mine_over_time;		// Ƿ³ʱ
	bool is_area_over_time;		// Ƿʱ, ʱֳʱԱʱ
	time_t time_area_over_time; // ʱʼʱ
	time_t time_over_time;		// ³ʱʼʱ
	time_t time_area_forbidden; // ʱ
	time_t time_over_speed;		// ٿʼʱ
	time_t time_low_power;

	void set_reader(Reader* preader);
	bool is_pos_state_changed(int nval); // \״̬仯
	bool is_pos_state_pack_changed(int nval);
	void add_dist(_coordinate* dist);
	void remove_dist_head();
	string concat(int reader_id, int ant_id);
	time_t get_working_time();
	string get_state_text();
	string get_acc_text();
	double get_speed();
	int get_effictive_dist_count(int offset = 0);
	void set_reader_path(ReaderPathMap *rpm);
	void set_reader_path(TDOAReaderPathMap* trpm);
public:
	// ˲㷨
	//CalLocation* cal_location;
	CalLocation3* cal_location3;
	//Point2* p2_anchors;
	Point3* p3_anchors;
	//bool is_init_kalman;
	CKalmanFilter* m_pKalmanFilter;
	//int m_max_stamp; // ʱɼ
	list<sync_data> m_syncNumList;

	int last_s_locate_reader[2];	//һζλɹķվϢ

	double ins_weight;
	double uwb_weight;
	double weight;

	bool is_anchor_changed;
	void get_coordinate();
	void get_coordinate(int cnt);
	void get_coordinate_3d(int cnt);
	void get_coordinate_2d(int cnt);
	void set_anchors(int cnt);

	void EnableFilter(int nType);
	int FindDistMap(int cardstamp);
public: // ɼĵײ
	int reader_tickcount; 
	int time_stamp; // λʱ
	int ranging_type; //  toftdoa
	int accelerate_state; // ٶ
	int antenna_id; // ߺ
	double antenna_angle; // ߽Ƕ
	double distance; // 
	int64_t flying_time; // ʱ
	int power_state; // 
	unsigned short sync_num;

	int time_stamp_last; // λʱ
	int context_type_last; //  toftdoa
	int accelerate_state_last; // ٶ
	int antenna_id_last; // ߺ
	double antenna_angle_last; // ߽Ƕ
	double distance_last; // 	
	int64_t flying_time_last; // ʱ
	int power_state_last; // 

	int reader_id_last;	//һζλʱķվid

	string str_his_time;
	string str_rec_time;
};

class Dept
{
public:
	Dept();
	~Dept();
	Dept(int id, string name);
private:
public:
	int dept_id;
	string dept_name;
	
	CardMap dept_card_list_person;
	CardMap dept_card_list_vehicle;
};

/*
 * ͼ·
*/
class ReaderPath{
public:
	ReaderPath(){
		bIsInit = false;
		nRealCalcPoints = 0;
		x[0] = x[1] = y[0] = y[1] = 0;
		for(int i=0;i<MAX_CALC_POINTS;i++){
			px[i] = py[i] = pz[i] = 0;
		}
	}
public:
	//TOFԣx,yʾ1,2߶Ӧ
	//TDOAԣx,yʾF1,F2ͬڷվi,i+1
	int nRealCalcPoints;
	double x[2];
	double y[2];
	double z[2];
	double px[MAX_CALC_POINTS];
	double py[MAX_CALC_POINTS];
	double pz[MAX_CALC_POINTS];

	bool bIsInit;
};

#endif //YASERVER_CLASSDEF_H_